#include <bits/stdc++.h>
#define endl '\n'
#define ll long long
using namespace std;
#define maxn 100005
#define lg 34
ll n,q;
ll a[maxn];
ll bit[lg];
void add(ll x,ll c){
    for(ll j = 0;j<lg;j++){
        if((1LL<<j)&x) bit[j]+=c;
    }
}
int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    for(ll i = 1;i<=n;i++){
        cin >> a[i];
        add(a[i],1);
    }
    cin >> q;
    while(q--){
        ll tip; cin >> tip;
        if(tip==0){
            ll k; cin >> k;
            ll ans = 0;
            for(ll j = 0;j<lg;j++){
                if(bit[j]>=k) ans+=(1LL<<j);
            }
            cout<<ans<<endl;
        }else{
            ll i,x; cin >> i >> x;
            add(a[i],-1);
            a[i] = x;
            add(a[i],1);
        }
    }
    return 0;
}